# PerfectScale Autoscaler Objects' Events

<table><thead><tr><th width="116">Event name</th><th width="139">Object</th><th width="110">Event type</th><th width="127">Event message</th><th>Description</th></tr></thead><tbody><tr><td><code>RefObjectNotFound</code></td><td><p></p><p><code>WorkloadAutomationConfig</code></p></td><td><code>Warning</code></td><td>Workload specified in TargetRef not found.</td><td>The event indicates that the K8s object specified in the TargetRef of the <code>Workload Automation Config</code> does not exist. The event could appear only in the config creation stage.</td></tr><tr><td><code>UpdatingWorkload</code></td><td><code>WorkloadAutomationStatus</code> (k8s object associated with the workload, e.g. <code>Job/CronJob</code>)</td><td><code>Normal</code></td><td>Received new resource recommendations for <code>{objectNamespace}</code>/<code>{objectName}</code></td><td><p>This event is applicable only to non-restartable workloads, such as <code>Jobs</code> and <code>CronJobs</code>.</p><p>The event indicates that new resource recommendations have been applied to <code>WorkloadAutomationStatus</code> (moved from <code>target</code> to <code>current</code> section).</p><p>Since the autoscaler cannot restart such workloads, new recommendations will be applied to pods during the next pod creation scheduled by K8s.</p></td></tr><tr><td><code>RestartingWorkload</code></td><td><code>WorkloadAutomationStatus</code> (k8s object associated with the workload, e.g. <code>Deployment/DaemonSet/StatefulSet</code>)</td><td><code>Normal</code></td><td>Received new resource recommendations for <code>{objectNamespace}</code>/<code>{objectName}</code></td><td><p>The event is only relevant for the restartable workloads (e.g., <code>Deployment</code>/<code>DaemonSet</code>/<code>StatefulSet</code>).</p><p>The event indicates that new resource recommendations have been applied to <code>WorkloadAutomationStatus</code> (moved from <code>target</code> to <code>current</code> section), AND autoscaler started rollout-restart for the workload (to apply the new recommendations).</p><p>Restart is needed for pod re-creation to apply the new recommendations.</p></td></tr><tr><td><code>RestartFailed</code></td><td><code>WorkloadAutomationStatus</code> (k8s object associated with the workload, e.g. <code>Deployment/DaemonSet/StatefulSet</code>)</td><td><code>Warning</code></td><td>Failed to restart <code>{objectNamespace}</code>/<code>{objectName}</code>: <code>{errorMessage}</code></td><td><p>The event is only relevant for restartable workloads (e.g., <code>Deployment</code>/<code>DaemonSet</code>/<code>StatefulSet</code>).</p><p>The event indicates that the restart failed from the autoscaler perspective. Possible reasons:</p><ul><li>We failed to start the restart process (the k8s client returned an error on the http patch request).</li><li>The deadline for restarting all pods has been exceeded (means not all pods have our latest <code>restartedAt</code> annotation and have running state).</li></ul></td></tr><tr><td><code>MutatingPod</code></td><td><code>WorkloadAutomationStatus</code></td><td><code>Normal</code></td><td>Applying PerfectScale recommendations to <code>{podNamespace}</code>/<code>{podName}</code></td><td>The event indicates that recommendations for the specified pod exist and can be applied (no R1 happened, etc.).</td></tr><tr><td><code>MutatedPod</code></td><td><code>WorkloadAutomationStatus</code></td><td><code>Normal</code></td><td>Successfully applied PerfectScale recommendations to <code>{podNamespace}</code>/<code>{podName}</code></td><td>The event indicates that recommendations for the specified pod were properly converted to JSON and returned to k8s. Therefore, recommendations should be applied to the pod.</td></tr><tr><td><code>MutatePodFailed</code></td><td><code>WorkloadAutomationStatus</code></td><td><code>Warning</code></td><td>Failed to apply PerfectScale recommendations to <code>{podNamespace}</code>/<code>{podName}</code></td><td>The event indicates that recommendations for the specified pod can not be properly converted to JSON and, as a result - were not returned to K8s. Therefore, recommendations will not be applied to the pod.</td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.perfectscale.io/product-overview/perfectscale-autoscaler-objects-events.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
